<script setup>
import {
  BCollapse,
  BDropdownItem,
  BDropdownHeader,
  BNavbar,
  BNavbarBrand,
  BNavItem,
  BNavItemDropdown,
  BNavbarNav,
  BNavbarToggle,
} from 'bootstrap-vue-next';
import { inject, computed } from 'vue';

import Logo from '@images/gitlab_logo.svg';

import ContributorLevelBadge from './ContributorLevelBadge.vue';
import LevelProgress from './LevelProgress.vue';
import ThemeSwitcher from './ThemeSwitcher.vue';

const vueData = inject('vueData');
const username = vueData.username;
const signedIn = computed(() => typeof (vueData.username) === 'string');
</script>

<template>
  <BNavbar
    class="navbar-dark"
    toggleable="sm"
  >
    <BNavbarToggle
      target="main-nav-collapse"
    />
    <BNavbarBrand
      tag="h1"
      class="mb-0"
      :to="{ name: 'home' }"
    >
      <img
        class="navbar-brand-logo"
        :src="Logo"
        alt="GitLab logo"
      >
      <span class="navbar-brand-text ms-3">Contributors</span>
    </BNavbarBrand>
    <BCollapse
      id="main-nav-collapse"
      is-nav
    >
      <BNavbarNav>
        <BNavItem :to="{ name: 'leaderboard' }">
          Leaderboard
        </BNavItem>
        <BNavItem :to="{ name: 'organizations' }">
          Organizations
        </BNavItem>
        <BNavItem :to="{ name: 'rewards' }">
          Rewards
        </BNavItem>
      </BNavbarNav>
      <BNavbarNav class="ms-auto mb-lg-0">
        <ThemeSwitcher />
        <BNavItemDropdown
          v-if="signedIn"
        >
          <template #button-content>
            <ContributorLevelBadge
              :contributor-level="vueData.contributorLevel"
              :badge-size="25"
            />
            <span class="mx-2">{{ username }}</span>
          </template>
          <BDropdownHeader>
            <div class="mb-2">Level progress</div>
            <LevelProgress minimized />
          </BDropdownHeader>
          <BDropdownItem :to="{ name: 'user', params: { userHandle: vueData.username } }">
            Profile
          </BDropdownItem>
          <BDropdownItem :href="`https://gitlab.com/${username}`">
            GitLab profile
          </BDropdownItem>
          <BDropdownItem :to="{ name: 'documentation', params: { page: 'user-guide' } }">
            User guide
          </BDropdownItem>
          <BDropdownItem href="/logout">
            Logout
          </BDropdownItem>
        </BNavItemDropdown>
        <template v-else>
          <BNavItem :to="{ name: 'documentation', params: { page: 'user-guide' } }">
            User Guide
          </BNavItem>
          <BNavItem href="/login">
            Login
          </BNavItem>
        </template>
      </BNavbarNav>
    </BCollapse>
  </BNavbar>
</template>
